std::__debug::unordered_multiset< _Value, _Hash, _Pred, _Alloc > Class Template Reference
Inheritance diagram for std::__debug::unordered_multiset< _Value, _Hash, _Pred, _Alloc >:
[legend]

## Public Types

typedef _Base::allocator_type | allocator_type
typedef __gnu_debug::_Safe_iterator< _Base_const_iterator, unordered_multiset > | const_iterator
typedef __gnu_debug::_Safe_local_iterator< _Base_const_local_iterator, unordered_multiset > | const_local_iterator
typedef _Base::hasher | hasher
typedef __gnu_debug::_Safe_iterator< _Base_iterator, unordered_multiset > | iterator
typedef _Base::key_equal | key_equal
typedef _Base::key_type | key_type
typedef __gnu_debug::_Safe_local_iterator< _Base_local_iterator, unordered_multiset > | local_iterator
using | node_type = typename _Base::node_type
typedef _Base::size_type | size_type
typedef _Base::value_type | value_type

## Public Member Functions

| unordered_multiset (_Base_ref __x)
template<typename _InputIterator >
| unordered_multiset (_InputIterator __first, _InputIterator __last, size_type __n, const allocator_type &__a)
template<typename _InputIterator >
| unordered_multiset (_InputIterator __first, _InputIterator __last, size_type __n, const hasher &__hf, const allocator_type &__a)
template<typename _InputIterator >
| unordered_multiset (_InputIterator __first, _InputIterator __last, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
| unordered_multiset (const allocator_type &__a)
| unordered_multiset (const unordered_multiset &)=default
| unordered_multiset (const unordered_multiset &__uset, const allocator_type &__a)
| unordered_multiset (initializer_list< value_type > __l, size_type __n, const allocator_type &__a)
| unordered_multiset (initializer_list< value_type > __l, size_type __n, const hasher &__hf, const allocator_type &__a)
| unordered_multiset (initializer_list< value_type > __l, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
| unordered_multiset (size_type __n, const allocator_type &__a)
| unordered_multiset (size_type __n, const hasher &__hf, const allocator_type &__a)
| unordered_multiset (size_type __n, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
| unordered_multiset (unordered_multiset &&)=default
| unordered_multiset (unordered_multiset &&__uset, const allocator_type &__a) noexcept(noexcept(_Base(std::move(__uset._M_base()), __a)))
const _Base & | _M_base () const noexcept
_Base & | _M_base () noexcept
void | _M_swap (_Safe_container &__x) noexcept
const_iterator | begin () const noexcept
iterator | begin () noexcept
local_iterator | begin (size_type __b)
const_local_iterator | begin (size_type __b) const
size_type | bucket_size (size_type __b) const
const_iterator | cbegin () const noexcept
const_local_iterator | cbegin (size_type __b) const
const_iterator | cend () const noexcept
const_local_iterator | cend (size_type __b) const
void | clear () noexcept
template<typename... _Args>
iterator | emplace (_Args &&... __args)
template<typename... _Args>
iterator | emplace_hint (const_iterator __hint, _Args &&... __args)
const_iterator | end () const noexcept
iterator | end () noexcept
local_iterator | end (size_type __b)
const_local_iterator | end (size_type __b) const
std::pair< iterator, iterator > | equal_range (const key_type &__key)
std::pair< const_iterator, const_iterator > | equal_range (const key_type &__key) const
size_type | erase (const key_type &__key)
iterator | erase (const_iterator __first, const_iterator __last)
iterator | erase (const_iterator __it)
iterator | erase (iterator __it)
node_type | extract (const key_type &__key)
node_type | extract (const_iterator __position)
iterator | find (const key_type &__key)
const_iterator | find (const key_type &__key) const
template<typename _InputIterator >
void | insert (_InputIterator __first, _InputIterator __last)
iterator | insert (const value_type &__obj)
iterator | insert (const_iterator __hint, const value_type &__obj)
iterator | insert (const_iterator __hint, node_type &&__nh)
iterator | insert (const_iterator __hint, value_type &&__obj)
iterator | insert (node_type &&__nh)
void | insert (std::initializer_list< value_type > __l)
iterator | insert (value_type &&__obj)
float | max_load_factor () const noexcept
void | max_load_factor (float __f)
unordered_multiset & | operator= (const unordered_multiset &)=default
unordered_multiset & | operator= (initializer_list< value_type > __l)
unordered_multiset & | operator= (unordered_multiset &&)=default
void | swap (unordered_multiset &__x) noexcept(noexcept(declval< _Base & >().swap(__x)))

## Public Attributes

_Safe_iterator_base * | _M_const_iterators
_Safe_iterator_base * | _M_const_local_iterators
_Safe_iterator_base * | _M_iterators
_Safe_iterator_base * | _M_local_iterators
unsigned int | _M_version

## Protected Member Functions

void | _M_detach_all ()
void | _M_detach_singular ()
__gnu_cxx::__mutex & | _M_get_mutex () throw ()
void | _M_invalidate_all ()
void | _M_invalidate_all () const
template<typename _Predicate >
void | _M_invalidate_if (_Predicate __pred)
template<typename _Predicate >
void | _M_invalidate_local_if (_Predicate __pred)
void | _M_invalidate_locals ()
void | _M_revalidate_singular ()
_Safe_container & | _M_safe () noexcept
void | _M_swap (_Safe_sequence_base &__x) noexcept
void | _M_swap (_Safe_unordered_container_base &__x) noexcept

## Friends

template<typename _ItT , typename _SeqT , typename _CatT >
class | ::__gnu_debug::_Safe_iterator
template<typename _ItT , typename _SeqT >
class | ::__gnu_debug::_Safe_local_iterator

## Detailed Description

### template<typename _Value, typename _Hash = std::hash<_Value>, typename _Pred = std::equal_to<_Value>, typename _Alloc = std::allocator<_Value>>
class std::__debug::unordered_multiset< _Value, _Hash, _Pred, _Alloc >

Class std::unordered_multiset with safety/checking/debug instrumentation.

Definition at line 679 of file debug/unordered_set.

## Member Function Documentation

## _M_detach_all()

void __gnu_debug::_Safe_unordered_container_base::_M_detach_all | ( |  | ) |

protected inherited

Detach all iterators, leaving them singular.

## _M_detach_singular()

void __gnu_debug::_Safe_sequence_base::_M_detach_singular | ( |  | ) |

protected inherited

Detach all singular iterators.

Postcondition
  for all iterators i attached to this sequence, i->_M_version == _M_version.

## _M_get_mutex()

__gnu_cxx::__mutex& __gnu_debug::_Safe_sequence_base::_M_get_mutex | ( |  | ) |
throw | ( |
| ) |  |

protected inherited

For use in _Safe_sequence.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

## _M_invalidate_all()

void __gnu_debug::_Safe_sequence_base::_M_invalidate_all | ( |  | ) | const

inline protected inherited

Invalidates all iterators.

Definition at line 256 of file safe_base.h.

References __gnu_debug::_Safe_sequence_base::_M_version.

## _M_invalidate_if()

template<typename _Container >
template<typename _Predicate >

void __gnu_debug::_Safe_unordered_container< _Container >::_M_invalidate_if | ( | _Predicate | __pred | ) |

protected inherited

Invalidates all iterators `x` that reference this container, are not singular, and for which `__pred(x)` returns `true`. `__pred` will be invoked with the normal iterators nested in the safe ones.

Definition at line 37 of file safe_unordered_container.tcc.

## _M_invalidate_local_if()

template<typename _Container >
template<typename _Predicate >

void __gnu_debug::_Safe_unordered_container< _Container >::_M_invalidate_local_if | ( | _Predicate | __pred | ) |

protected inherited

Invalidates all local iterators `x` that reference this container, are not singular, and for which `__pred(x)` returns `true`. `__pred` will be invoked with the normal local iterators nested in the safe ones.

Definition at line 69 of file safe_unordered_container.tcc.

## _M_revalidate_singular()

void __gnu_debug::_Safe_sequence_base::_M_revalidate_singular | ( |  | ) |

protected inherited

Revalidates all attached singular iterators. This method may be used to validate iterators that were invalidated before (but for some reason, such as an exception, need to become valid again).

## _M_swap() [1/2]

void __gnu_debug::_Safe_sequence_base::_M_swap | ( | _Safe_sequence_base & | __x | ) |

protected noexcept inherited

Swap this sequence with the given sequence. This operation also swaps ownership of the iterators, so that when the operation is complete all iterators that originally referenced one container now reference the other container.

## _M_swap() [2/2]

void __gnu_debug::_Safe_unordered_container_base::_M_swap | ( | _Safe_unordered_container_base & | __x | ) |

protected noexcept inherited

Swap this container with the given container. This operation also swaps ownership of the iterators, so that when the operation is complete all iterators that originally referenced one container now reference the other container.

## Member Data Documentation

## _M_const_iterators

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_const_iterators

inherited

The list of constant iterators that reference this container.

Definition at line 197 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

## _M_const_local_iterators

_Safe_iterator_base* __gnu_debug::_Safe_unordered_container_base::_M_const_local_iterators

inherited

The list of constant local iterators that reference this container.

Definition at line 130 of file safe_unordered_base.h.

## _M_iterators

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_iterators

inherited

The list of mutable iterators that reference this container.

Definition at line 194 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

## _M_local_iterators

_Safe_iterator_base* __gnu_debug::_Safe_unordered_container_base::_M_local_iterators

inherited

The list of mutable local iterators that reference this container.

Definition at line 127 of file safe_unordered_base.h.

## _M_version

unsigned int __gnu_debug::_Safe_sequence_base::_M_version

mutable inherited

The container version number. This number may never be 0.

Definition at line 200 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence_base::_M_invalidate_all().

The documentation for this class was generated from the following file:

- debug/unordered_set